/****************************************************************/
/*                                                              */
/*                            Memory                            */
/*                                                              */
/*  Description: Fonctions de manipulation de la memoire        */
/*  Auteur:      LePhenixNoir                                   */
/*  Date:        14.02.2014                                     */
/*  Fichier:     memory.c - Code des fonctions                  */
/*                                                              */
/****************************************************************/

#ifndef __FXLIB_H__
  #include "fxlib.h"
#endif

#ifndef _STDIO
  #include <stdio.h>
#endif

#ifndef _STDLIB
  #include <stdlib.h>
#endif

// Adaptez l'instruction suivante a votre programme
extern unsigned int key;

int str_len(char *str)
{
  int i=0;
  while(*(str+i)) i++;
  return i;
}

char *str_cut(void *str,int begin,int length)
{
  char *ch;
  int i;

  ch = (void *)malloc(50);
  for(i=0;i<length;i++)
    *(ch+i) = *((char *)str+i+begin);
  *(ch+length)=0;

  return ch;
}

int memory_createfile (char *adresse, int size)
{
  FONTCHARACTER *adr;
  int i;

  adr = malloc((strlen(adresse)+1)*sizeof(FONTCHARACTER));
  for(i=0;i<strlen(adresse);i++) *(adr+i) = *(adresse+i);
  return Bfile_CreateFile(adr,size);
}

int memory_createdir (char *adresse)
{
  FONTCHARACTER *adr;
  int i;

  adr = malloc((strlen(adresse)+1)*sizeof(FONTCHARACTER));
  for(i=0;i<strlen(adresse);i++) *(adr+i) = *(adresse+i);
  return Bfile_CreateDirectory(adr);
}

int memory_openfile(char *adresse, int mode)
{
  FONTCHARACTER *adr;
  int i;

  adr = malloc((strlen(adresse)+1)*sizeof(FONTCHARACTER));
  for(i=0;i<strlen(adresse);i++) *(adr+i) = *(adresse+i);
  return Bfile_OpenFile(adr,mode);
}

int memory_closefile(int handle)
{
  return Bfile_CloseFile(handle);
}

int memory_writefile(int handle, char *chaine, int length)
{
  return Bfile_WriteFile(handle,chaine,length);
}

int memory_readfile(int handle, void *buffer, int size, int pos)
{
  return Bfile_ReadFile(handle,buffer,size,pos);
}

int memory_seekfile(int handle, int pos)
{
  return Bfile_SeekFile(handle,pos);
}

int memory_filesize(int handle)
{
  return Bfile_GetFileSize(handle);
}

int memory_deletefile(char *adresse)
{
  FONTCHARACTER *adr;
  int i;

  adr = malloc((strlen(adresse)+1)*sizeof(FONTCHARACTER));
  for(i=0;i<strlen(adresse);i++) *(adr+i) = *(adresse+i);
  return Bfile_DeleteFile(adr);
}

int memory_find(char **files, char *adresse)
{
  FONTCHARACTER *adr;
  FONTCHARACTER found[30];
  FILE_INFO fileInfo;
  int searchHandle,i=1,j,x;

  adr = malloc((strlen(adresse)+1)*sizeof(FONTCHARACTER));
  for(j=0;j<strlen(adresse);j++) *(adr+j) = *(adresse+j);

  if(x = Bfile_FindFirst(adr,&searchHandle,found,&fileInfo)) return 0;
  for(j=0;j<14 && *(found+j);j++) *(*(files)+j) = *(found+j);

  while(Bfile_FindNext(searchHandle,found,&fileInfo)==0)
  {
    for(j=0;j<14 && *(found+j);j++) *(*(files+i)+j) = *(found+j);
    i++;
  }
  Bfile_FindClose(searchHandle);
  return i;
}

int memory_exists(char *adresse)
{
  char *file[1];
  *file = malloc(14); **file=0;
  memory_find(file,adresse);
  if(**file) return 1;
  return 0;
}

int memory_load(int n, char **files, int extension)
{
  int i;
  int p=0, offset=0;
  if(!extension) for(i=0;i<n;i++) *(files+i) = str_cut(*(files+i),0,str_len(*(files+i))-4);

  while(1)
  {
    Bdisp_AllClr_DDVRAM();
    locate(2,1); Print((const unsigned char *)"Choose file to load");
    Bdisp_DrawLineVRAM(20,12,107,12);

    for(i=0;i<(n>6?6:n);i++) PrintMini(32,7*i+18,(const unsigned char *)*(files+offset+i),0);
    if(offset>0) PrintMini(90,18,(const unsigned char *)"\346\234",0);
    if(offset+6<n) PrintMini(90,53,(const unsigned char *)"\346\235",0);
    PrintMini(24,7*p+18,(const unsigned char *)"\023",0);

    while(1)
    {
      GetKey(&key);
      if(key==30002) return -1;
      if(key==30004) break;
      if(key==30018 && (offset||p)) { if(p) p--; else offset--; break; }
      if(key==30023 && (offset+6<n||(p<5&&p+1<n))) { if(p<5) p++; else offset++; break; }
    }
    if(key==30004) break;
  }

  return offset+p;
}
